/*
 * ex: set ro:
 * DO NOT EDIT.
 * generated by smc (http://smc.sourceforge.net/)
 * from file : LifecycleHandlerContext.sm
 */

package org.sonatype.sisu.goodies.lifecycle;


public class LifecycleHandlerContext
    extends statemap.FSMContext
{
//---------------------------------------------------------------
// Member methods.
//

    public LifecycleHandlerContext(LifecycleHandler owner)
    {
        super (MainMap.Stopped);

        _owner = owner;
    }

    public LifecycleHandlerContext(LifecycleHandler owner, LifecycleHandlerState initState)
    {
        super (initState);

        _owner = owner;
    }

    public synchronized void enterStartState()
    {
        getState().Entry(this);
        return;
    }

    public synchronized void fail()
    {
        _transition = "fail";
        getState().fail(this);
        _transition = "";
        return;
    }

    public synchronized void start()
    {
        _transition = "start";
        getState().start(this);
        _transition = "";
        return;
    }

    public synchronized void started()
    {
        _transition = "started";
        getState().started(this);
        _transition = "";
        return;
    }

    public synchronized void stop()
    {
        _transition = "stop";
        getState().stop(this);
        _transition = "";
        return;
    }

    public synchronized void stopped()
    {
        _transition = "stopped";
        getState().stopped(this);
        _transition = "";
        return;
    }

    public LifecycleHandlerState getState()
        throws statemap.StateUndefinedException
    {
        if (_state == null)
        {
            throw(
                new statemap.StateUndefinedException());
        }

        return ((LifecycleHandlerState) _state);
    }

    protected LifecycleHandler getOwner()
    {
        return (_owner);
    }

    public void setOwner(LifecycleHandler owner)
    {
        if (owner == null)
        {
            throw (
                new NullPointerException(
                    "null owner"));
        }
        else
        {
            _owner = owner;
        }

        return;
    }

//---------------------------------------------------------------
// Member data.
//

    transient private LifecycleHandler _owner;

    public static abstract class LifecycleHandlerState
        extends statemap.State
    {
    //-----------------------------------------------------------
    // Member methods.
    //

        protected LifecycleHandlerState(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context) {}
        protected void Exit(LifecycleHandlerContext context) {}

        protected void fail(LifecycleHandlerContext context)
        {
            Default(context);
        }

        protected void start(LifecycleHandlerContext context)
        {
            Default(context);
        }

        protected void started(LifecycleHandlerContext context)
        {
            Default(context);
        }

        protected void stop(LifecycleHandlerContext context)
        {
            Default(context);
        }

        protected void stopped(LifecycleHandlerContext context)
        {
            Default(context);
        }

        protected void Default(LifecycleHandlerContext context)
        {
            throw (
                new statemap.TransitionUndefinedException(
                    "State: " +
                    context.getState().getName() +
                    ", Transition: " +
                    context.getTransition()));
        }

    //-----------------------------------------------------------
    // Member data.
    //
    }

    /* package */ static abstract class MainMap
    {
    //-----------------------------------------------------------
    // Member methods.
    //

    //-----------------------------------------------------------
    // Member data.
    //

        //-------------------------------------------------------
        // Constants.
        //
        public static final MainMap_Starting Starting =
            new MainMap_Starting("MainMap.Starting", 0);
        public static final MainMap_Started Started =
            new MainMap_Started("MainMap.Started", 1);
        public static final MainMap_Stopping Stopping =
            new MainMap_Stopping("MainMap.Stopping", 2);
        public static final MainMap_Stopped Stopped =
            new MainMap_Stopped("MainMap.Stopped", 3);
        public static final MainMap_Failed Failed =
            new MainMap_Failed("MainMap.Failed", 4);
        private static final MainMap_Default Default =
            new MainMap_Default("MainMap.Default", -1);

    }

    protected static class MainMap_Default
        extends LifecycleHandlerState
    {
    //-----------------------------------------------------------
    // Member methods.
    //

        protected MainMap_Default(String name, int id)
        {
            super (name, id);
        }
    //-----------------------------------------------------------
    // Member data.
    //
    }

    private static final class MainMap_Starting
        extends MainMap_Default
    {
    //-------------------------------------------------------
    // Member methods.
    //

        private MainMap_Starting(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context)
            {
                LifecycleHandler ctxt = context.getOwner();

            ctxt.log("Starting");
            return;
        }

        protected void fail(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Failed);
            (context.getState()).Entry(context);
            return;
        }

        protected void started(LifecycleHandlerContext context)
        {
            LifecycleHandler ctxt = context.getOwner();


            (context.getState()).Exit(context);
            context.clearState();
            try
            {
                ctxt.doStart();
            }
            finally
            {
                context.setState(MainMap.Started);
                (context.getState()).Entry(context);
            }
            return;
        }

    //-------------------------------------------------------
    // Member data.
    //
    }

    private static final class MainMap_Started
        extends MainMap_Default
    {
    //-------------------------------------------------------
    // Member methods.
    //

        private MainMap_Started(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context)
            {
                LifecycleHandler ctxt = context.getOwner();

            ctxt.log("Started");
            return;
        }

        protected void fail(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Failed);
            (context.getState()).Entry(context);
            return;
        }

        protected void stop(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Stopping);
            (context.getState()).Entry(context);
            return;
        }

    //-------------------------------------------------------
    // Member data.
    //
    }

    private static final class MainMap_Stopping
        extends MainMap_Default
    {
    //-------------------------------------------------------
    // Member methods.
    //

        private MainMap_Stopping(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context)
            {
                LifecycleHandler ctxt = context.getOwner();

            ctxt.log("Stopping");
            return;
        }

        protected void fail(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Failed);
            (context.getState()).Entry(context);
            return;
        }

        protected void stopped(LifecycleHandlerContext context)
        {
            LifecycleHandler ctxt = context.getOwner();


            (context.getState()).Exit(context);
            context.clearState();
            try
            {
                ctxt.doStop();
            }
            finally
            {
                context.setState(MainMap.Stopped);
                (context.getState()).Entry(context);
            }
            return;
        }

    //-------------------------------------------------------
    // Member data.
    //
    }

    private static final class MainMap_Stopped
        extends MainMap_Default
    {
    //-------------------------------------------------------
    // Member methods.
    //

        private MainMap_Stopped(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context)
            {
                LifecycleHandler ctxt = context.getOwner();

            ctxt.log("Stopped");
            return;
        }

        protected void fail(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Failed);
            (context.getState()).Entry(context);
            return;
        }

        protected void start(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Starting);
            (context.getState()).Entry(context);
            return;
        }

    //-------------------------------------------------------
    // Member data.
    //
    }

    private static final class MainMap_Failed
        extends MainMap_Default
    {
    //-------------------------------------------------------
    // Member methods.
    //

        private MainMap_Failed(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(LifecycleHandlerContext context)
            {
                LifecycleHandler ctxt = context.getOwner();

            ctxt.log("Failed");
            ctxt.doFailed();
            return;
        }

        protected void fail(LifecycleHandlerContext context)
        {


            (context.getState()).Exit(context);
            context.setState(MainMap.Failed);
            (context.getState()).Entry(context);
            return;
        }

        protected void start(LifecycleHandlerContext context)
        {
            LifecycleHandler ctxt = context.getOwner();

            if (ctxt.isResettable())
            {

                (context.getState()).Exit(context);
                context.clearState();
                try
                {
                    ctxt.doReset();
                }
                finally
                {
                    context.setState(MainMap.Starting);
                    (context.getState()).Entry(context);
                }
            }
            else
            {
                super.start(context);
            }

            return;
        }

        protected void stop(LifecycleHandlerContext context)
        {
            LifecycleHandler ctxt = context.getOwner();

            if (ctxt.isResettable())
            {

                (context.getState()).Exit(context);
                context.clearState();
                try
                {
                    ctxt.doReset();
                }
                finally
                {
                    context.setState(MainMap.Stopping);
                    (context.getState()).Entry(context);
                }
            }
            else
            {
                super.stop(context);
            }

            return;
        }

    //-------------------------------------------------------
    // Member data.
    //
    }
}

/*
 * Local variables:
 *  buffer-read-only: t
 * End:
 */
